// CTVItemDataMgrFolders.cpp : Directory folder retrieval for CTVItemDataMgr class
//

#include "stdafx.h"
#include "TVItemData.h"
#include "TVItemDataMgr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

BOOL CTVItemDataMgr::AddFoldersRecursively( LPCTSTR szFolder, LPCTSTR szName, const LONG lParentID  )
{
	CFileFind	finder;
	CString		sFullPath = szFolder;
	BOOL        bContinue = FALSE;
   LONG        lNewID = 0;
   BOOL        bDepthIncremented = FALSE;

   if( WAIT_OBJECT_0 == WaitForSingleObject( GetShutdownEvent(), 0 )
      || lParentID > GetMaxCount( ) )
   {
         return FALSE;
   }

   InsertItem( szName, lParentID, lNewID );

	if (finder.FindFile( sFullPath + _T( "\\*.*" ) ) )
	{
      do
		{
			bContinue = (finder.FindNextFile() !=0 ); 

			if (	TRUE == finder.IsDirectory() && 
					FALSE == finder.IsDots() )
			{

            if( FALSE == bDepthIncremented )
            {
               IncCurrentDepth( );
               bDepthIncremented = TRUE;
            }

            if( GetCurrentDepth( ) < GetMaxDepth( ) )
            {
               if( !AddFoldersRecursively( 
                  CString( szFolder ) + _T( "\\" ) + finder.GetFileName( ),
                  finder.GetFileName( ),
                  lNewID ) )
               {
                  return FALSE;
               }
            }
			}
		} while (bContinue );

      if( TRUE == bDepthIncremented )
      {
         DecCurrentDepth( );
      }
	}

   return TRUE;
}

// Method:  InsertItem
// Purpose: Creates a new CLVItemData object and inserts it into the list
HRESULT CTVItemDataMgr::InsertItem( LPCTSTR szName, const LONG lParentID, LONG& lNewID )
{   
   HRESULT hr = S_OK;

   try
   {
      CAutoLockT< CTVItemDataMMap > lock( &m_TVItemDataMMap );

      lNewID = GetNextID( );
      m_TVItemDataMMap.insert( 
			CTVItemDataMMap::value_type( lParentID, 
				CTVItemData( szName, lNewID, lParentID ) ) );
   }
   catch(std::bad_alloc)
   {
      hr = E_OUTOFMEMORY;
   }

   return hr;
}