// VirtualTreeDlg.h : header file
//

#pragma once
#include "afxcmn.h"
#include "afxwin.h"

class CTVItemDataMgr;

// CVirtualTreeDlg dialog
class CVirtualTreeDlg : public CDialog
{
// Construction
public:
	CVirtualTreeDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_VIRTUALTREE_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

    // Class that manages creation of CTVItemData objects
    // using a secondary thread.  Illustrates proper resource
    // locking when sharing a std::vector between threads
    CTVItemDataMgr  m_TVItemDataMgr; 

	// Generated message map functions
	virtual BOOL      OnInitDialog();
	afx_msg void      OnPaint();
	afx_msg HCURSOR   OnQueryDragIcon();
   afx_msg void      OnBnClickedRetrieve();
   afx_msg void      OnBnClickedCancel();

   // Virtual Tree GetDispInfo handler
   afx_msg void      OnTvnGetdispinfoTree(NMHDR *pNMHDR, LRESULT *pResult);
	DECLARE_MESSAGE_MAP()
public:
   CButton           m_btnRetrieve;
   CButton           m_btnCancel;
   CComboBox         m_ctlDrives;
   CSpinButtonCtrl   m_ctlMaxCountSpin;
   CSpinButtonCtrl   m_ctlDepthSpin;
   CSpinButtonCtrl   m_ctlMultiplierSpin;
   CTreeCtrl         m_ctlTree;
   
   CString  m_sDrive;
   CString  m_sStatus;
   UINT     m_uMaxCount;
   UINT     m_uDepth;
   UINT     m_uMultiplier;

   void     SetStatusText( LPCTSTR szText );
   void     FillDrives( );
};
